import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { ColumnFormat } from './column-info';
import { NgForm } from '@angular/forms';
var AtGrid = (function () {
    function AtGrid() {
        /**Данные*/
        this.data = [];
        /**Колонки*/
        this.metaData = [];
        /**Количество строк на странице*/
        this.quRowOnPage = 10;
        /**Статический режим*/
        this.staticMode = true;
        /**Текущая страница*/
        this.currentPage = 0;
        /**Текущая страница*/
        this.imageSize = 100;
        /**Выделене какой-то позиции*/
        this.onSelect = new EventEmitter();
        /**Выделене какой-то позиции*/
        this.onLoad = new EventEmitter();
        /***/
        this.onChanged = new EventEmitter();
        /**Энум в компонет*/
        this.columnFormat = ColumnFormat;
        this.callbackSetCellStyle = function (row, column) { };
    }
    /**Инит компонента*/
    /**Инит компонента*/
    AtGrid.prototype.ngOnInit = /**Инит компонента*/
    function () {
    };
    /**После загрузки вьюхи*/
    /**После загрузки вьюхи*/
    AtGrid.prototype.ngAfterViewChecked = /**После загрузки вьюхи*/
    function () {
    };
    /**Выделить строку*/
    /**Выделить строку*/
    AtGrid.prototype.selectRow = /**Выделить строку*/
    function (item) {
        this.onSelect.emit(item);
    };
    /**Первая страница*/
    /**Первая страница*/
    AtGrid.prototype.firstPage = /**Первая страница*/
    function () {
        this.currentPage = 0;
    };
    /**Первая страница*/
    /**Первая страница*/
    AtGrid.prototype.lastPage = /**Первая страница*/
    function () {
        this.currentPage = this.getQuPage() - 1;
    };
    /**Первая страница*/
    /**Первая страница*/
    AtGrid.prototype.nextPage = /**Первая страница*/
    function () {
        if (this.currentPage < (this.getQuPage() - 1)) {
            this.currentPage++;
        }
        else {
            this.currentPage = this.getQuPage() - 1;
        }
    };
    /**Первая страница*/
    /**Первая страница*/
    AtGrid.prototype.prevPage = /**Первая страница*/
    function () {
        if (this.currentPage > 0) {
            this.currentPage--;
        }
        else {
            this.currentPage = 0;
        }
    };
    /**Количество страниц*/
    /**Количество страниц*/
    AtGrid.prototype.getQuPage = /**Количество страниц*/
    function () {
        var result = Math.ceil(this.applyFilter().length / this.quRowOnPage);
        if (result <= 0) {
            result = 1;
        }
        return result;
    };
    /**Номер страницы от 1*/
    /**Номер страницы от 1*/
    AtGrid.prototype.getHumanCurrentPage = /**Номер страницы от 1*/
    function () {
        return this.currentPage + 1;
    };
    AtGrid.prototype.applyFilter = function () {
        var result = [];
        for (var _i = 0, _a = this.data; _i < _a.length; _i++) {
            var item = _a[_i];
            var checkFilter = true;
            for (var _b = 0, _c = this.metaData; _b < _c.length; _b++) {
                var column = _c[_b];
                if (column.filterInfo.value !== '') {
                    if (item[column.name] != null && item[column.name].toString().indexOf(column.filterInfo.value) !== -1) {
                        // Условие правильное
                    }
                    else {
                        checkFilter = false;
                        break;
                    }
                }
            }
            if (checkFilter) {
                result.push(item);
            }
        }
        return result;
    };
    /**Получить строки для страницы*/
    /**Получить строки для страницы*/
    AtGrid.prototype.getRowForPage = /**Получить строки для страницы*/
    function () {
        var index = 0;
        var result = [];
        for (var _i = 0, _a = this.applyFilter(); _i < _a.length; _i++) {
            var item = _a[_i];
            if (index >= this.currentPage * this.quRowOnPage && index < (this.currentPage + 1) * this.quRowOnPage) {
                result.push(item);
            }
            index++;
        }
        return result;
    };
    /**Фильтр изменен*/
    /**Фильтр изменен*/
    AtGrid.prototype.filterChanged = /**Фильтр изменен*/
    function (filter) {
        console.log(filter);
    };
    /***/
    /***/
    AtGrid.prototype.mouseOver = /***/
    function (rowNum) {
        this.rowNumMouseOver = rowNum;
    };
    /***/
    /***/
    AtGrid.prototype.mouseOverCell = /***/
    function (cellOver) {
        this.cellOver = cellOver;
    };
    /***/
    /***/
    AtGrid.prototype.getCellId = /***/
    function (rowNum, colNum) {
        return "at_grid_cell_" + rowNum + "'_'" + colNum;
    };
    /**Ячейка изменена*/
    /**Ячейка изменена*/
    AtGrid.prototype.changedCell = /**Ячейка изменена*/
    function (param) {
        this.onChanged.emit(param);
    };
    /***/
    /***/
    AtGrid.prototype.isAllowEdit = /***/
    function (rowNum, column) {
        // && column === this.cellOver && rowNum === this.rowNumMouseOver
        return column.editable;
    };
    /***/
    /***/
    AtGrid.prototype.setDatetime = /***/
    function (item, column, value) {
        item[column.name] = new Date(value);
    };
    AtGrid.decorators = [
        { type: Component, args: [{
                    moduleId: module.id,
                    selector: 'at-grid',
                    styles: ["\n    .uneven_row{background-color:#f9f9f9}.even_row{background-color:#ffffff}.uneven_row_mouse_over{background-color:#e9f9f9}.even_row_mouse_over{background-color:#e9f9f9}.base_row_tr{cursor:pointer}.base_row_td{padding:10px}.base_header_tr{cursor:pointer}.base_header_td{padding:10px}input,select{width:100%}li{padding-left:200px}td.last{width:1px;white-space:nowrap}.at-table{border-radius:10px}\n  "],
                    template: "\n    <form name=\"form\" id=\"form\" #myForm=\"ngForm\">\n        <table width=\"100%\" style=\"width:100%\" border=\"1\" class=\"at-table\">\n            <thead>\n                <tr class=\"base_header_tr\">\n                    <td *ngFor=\"let column of metaData\"\n                        class=\"base_header_td\">\n                      <b>{{column.comment}}</b>\n                    </td>\n                </tr>\n                <tr>\n                    <td *ngFor=\"let column of metaData\">\n                        <input\n                                type=\"text\"\n                                [name]=\"column.name\"\n                                [id]=\"column.name\"\n                                [(ngModel)]=\"column.filterInfo.value\"\n                                (ngModelChange)=\"filterChanged($event)\"/>\n                    </td>\n                </tr>\n            </thead>\n            <tbody>\n                <tr *ngFor=\"let item of getRowForPage(); let idx = index\"\n                    [ngClass]=\"{ 'even_row': (idx % 2 == 0) && rowNumMouseOver != idx,\n                        'uneven_row': (idx % 2 == 1) && rowNumMouseOver != idx,\n                        'even_row_mouse_over': (idx % 2 == 0) && rowNumMouseOver == idx,\n                        'uneven_row_mouse_over': (idx % 2 == 1) && rowNumMouseOver == idx\n                    }\"\n                    class=\"base_row_tr\"\n                    (click)=\"selectRow(item)\"\n                    (mouseleave)=\"mouseOver(null)\"\n                    (mouseover)=\"mouseOver(idx)\"\n                >\n                    <td *ngFor=\"let column of metaData; let colNum = index\"\n                        style = \"height: 1px;\"\n                        class=\"base_row_td\" [ngStyle] = \"callbackSetCellStyle(item, column)\"\n                        (mouseleave)=\"mouseOverCell(null)\"\n                        (mouseover)=\"mouseOverCell(column)\"\n                    >\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Number && !isAllowEdit(idx, column)\" align=\"right\"\n                             [id]=\"getCellId(idx, colNum)\" style=\"height: 100%\">\n                            {{item[column.name]|number}}\n                        </div>\n                        <div *ngIf=\"column.columnFormat == columnFormat.Number && isAllowEdit(idx, column)\" align=\"right\"\n                             [id]=\"getCellId(idx, colNum)\"  style=\"height: 100%\">\n                            <input type=\"number\"  pattern=\"^[-+]?[0-9]*[.,]?[0-9]+(?:[eE][-+]?[0-9]+)?$\"\n                                   [name]=\"'input' + getCellId(idx, colNum)\" [id]=\"'input' + getCellId(idx, colNum)\"\n                                   style=\"border: none;\"\n                                   [ngClass]=\"{ 'even_row': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                   [(ngModel)]=\"item[column.name]\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                                   (click)=\"$event.stopPropagation()\"\n                            />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Currency && !isAllowEdit(idx, column)\" align=\"right\"\n                             [id]=\"getCellId(idx, colNum)\" style=\"height: 100%\">\n                            {{item[column.name]|number:'1.2-2'}}\n                        </div>\n                        <div *ngIf=\"column.columnFormat == columnFormat.Currency && isAllowEdit(idx, column)\" align=\"right\"\n                             [id]=\"getCellId(idx, colNum)\" style=\"height: 100%\">\n                            <input type=\"number\"  pattern=\"^[-+]?[0-9]*[.,]?[0-9]+(?:[eE][-+]?[0-9]+)?$\"\n                                   [name]=\"'input' + getCellId(idx, colNum)\" [id]=\"'input' + getCellId(idx, colNum)\"\n                                   style=\"border: none;\"\n                                   [ngClass]=\"{ 'even_row': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                   [(ngModel)]=\"item[column.name]\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                                   (click)=\"$event.stopPropagation()\"\n                            />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Date && !isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\" style=\"height: 100%\">\n                            {{item[column.name]|date:'dd.MM.yyyy'}}\n                        </div>\n                        <div *ngIf=\"column.columnFormat == columnFormat.Date && isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\" style=\"height: 100%\"\n                             (click)=\"$event.stopPropagation()\">\n                            <input type=\"date\"  [name]=\"'input' + getCellId(idx, colNum)\"\n                                   [id]=\"'input' + getCellId(idx, colNum)\"\n                                   style=\"border: none;\"\n                                   [ngClass]=\"{ 'even_row': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                   [ngModel]=\"item[column.name] | date:'yyyy-MM-dd'\"\n                                   (ngModelChange)=\"item[column.name] = $event\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                                   (click)=\"$event.stopPropagation()\"\n                            />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Datetime && !isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\" style=\"height: 100%\">\n                            {{item[column.name]|date:'dd.MM.yyyy hh:mm'}}\n                        </div>\n                        <div *ngIf=\"column.columnFormat == columnFormat.Datetime && isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\" style=\"height: 100%\"\n                             (click)=\"$event.stopPropagation()\">\n                            <input type=\"datetime-local\"  [name]=\"'input' + getCellId(idx, colNum)\"\n                                   [id]=\"'input' + getCellId(idx, colNum)\"\n                                   style=\"border: none;\"\n                                   [ngClass]=\"{ 'even_row': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                   [ngModel]=\"item[column.name] | date:'yyyy-MM-ddThh:mm'\"\n                                   (ngModelChange)=\"setDatetime(item, column, $event)\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                                   (click)=\"$event.stopPropagation()\"\n                            />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Default && !isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             style=\"height: 100%\">\n                            {{item[column.name]}}\n                        </div>\n                        <div *ngIf=\"column.columnFormat == columnFormat.Default && isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             style=\"height: 100%\">\n                            <input type=\"text\"  [name]=\"'input' + getCellId(idx, colNum)\"\n                                   [id]=\"'input' + getCellId(idx, colNum)\"\n                                   style=\"border: none;\"\n                                   [ngClass]=\"{ 'even_row': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                   [(ngModel)]=\"item[column.name]\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                                   (click)=\"$event.stopPropagation()\"\n                            />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Boolean\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             style=\"height: 100%\">\n                            <input type=\"checkbox\"\n                                   [id]=\"'col_' + column.name + '_' + idx\" [name]=\"'col_' + column.name + '_' + idx\"\n                                   style=\"border: none;\"\n                                   [ngClass]=\"{ 'even_row': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                   [(ngModel)]=\"item[column.name]\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                            />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Picture && item[column.name] != null\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             style=\"height: 100%\">\n                            <img [width]=\"imageSize\" [height]=\"imageSize\" [src]=\"item[column.name] | safeHtml\" />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Template && item[column.name] != null\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             style=\"height: 100%\">\n                            <ng-container *ngTemplateOutlet=\"item[column.name].template;context:item[column.name].context\"></ng-container>\n                        </div>\n                    </td>\n                </tr>\n            </tbody>\n        </table>\n        <button (click)=\"firstPage()\" type=\"button\"> << </button>\n        <button (click)=\"prevPage()\" type=\"button\"> < </button>\n        {{getHumanCurrentPage()}} \u0438\u0437 {{getQuPage()}}\n        <button (click)=\"nextPage()\" type=\"button\"> > </button>\n        <button (click)=\"lastPage()\" type=\"button\"> >> </button>\n    </form>\n  "
                },] },
    ];
    /** @nocollapse */
    AtGrid.ctorParameters = function () { return []; };
    AtGrid.propDecorators = {
        "data": [{ type: Input },],
        "metaData": [{ type: Input },],
        "quRowOnPage": [{ type: Input },],
        "staticMode": [{ type: Input },],
        "currentPage": [{ type: Input },],
        "imageSize": [{ type: Input },],
        "callbackSetCellStyle": [{ type: Input },],
        "onSelect": [{ type: Output },],
        "form": [{ type: ViewChild, args: ['myForm',] },],
        "onLoad": [{ type: Output },],
        "onChanged": [{ type: Output },],
    };
    return AtGrid;
}());
export { AtGrid };
//# sourceMappingURL=at-grid.js.map