import { FilterInfo } from './filter-info';
export declare class ColumnInfo {
    name: string;
    comment: string;
    allowSort: boolean;
    filterInfo: FilterInfo;
    columnFormat: ColumnFormat;
    editable: boolean;
    constructor(name: string, comment: string, allowSort?: boolean, filterInfo?: FilterInfo, columnFormat?: ColumnFormat, editable?: boolean);
}
export declare enum ColumnFormat {
    Date = 0,
    Datetime = 1,
    Number = 2,
    Currency = 3,
    Default = 4,
    Boolean = 5,
    Picture = 6,
    Template = 7,
}
